
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>Fundamentals: Solving the Poisson equation</title>
    
    <link rel="stylesheet" href="_static/basic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="_static/custom.css" type="text/css" />
    <link rel="stylesheet" href="_static/bootstrap-sphinx.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    './',
        VERSION:     '1.6',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <script type="text/javascript" src="_static/bootstrap-sphinx.js"></script>
    <link rel="top" title="The FEniCS Tutorial Volume I" href="index.html" />
    <link rel="next" title="A Gallery of finite element solvers" href="._ftut1004.html" />
    <link rel="prev" title="Preliminaries" href="._ftut1002.html" />
  <meta charset='utf-8'>
  <meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
  <meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
  <meta name="apple-mobile-web-app-capable" content="yes">

  <!-- Default Bootstrap-->
  <link rel="stylesheet" href="_static/css/bootstrap.min.css"/>
  <link rel="shortcut icon" href="_static/fenics.ico" />
  <!-- Template styles CSS-->
  <link rel="stylesheet" href="_static/css/main.css"/>
  <link rel="stylesheet" href="_static/css/custom.css"/>
  <link rel="stylesheet" href="_static/css/font-awesome.min.css"/>
  <link rel="stylesheet" href="_static/css/animate.min.css"/>
  <link rel="stylesheet" href="_static/css/responsive.css"/>

  <!-- Template styles JS-->
  <script src="_static/slides.min.jquery.js"></script>
  <script type="text/javascript" src="_static/js/jquery-1.11.0.min.js"></script>
  <script type="text/javascript" src="_static/js/jquery-fix.js"></script>
  <script type="text/javascript" src="_static/js/bootstrap.js"></script>
  <script type="text/javascript" src="_static/js/bootstrap.min.js"></script>
  <script type="text/javascript" src="_static/js/wow.min.js"></script>
  <script type="text/javascript" src="_static/js/main.js"></script>
  <script type="text/javascript" src="_static/js/jquery.bcSwipe.js"></script>
  <script>
    $(document).ready(function() {
         $("#mycarousel").swiperight(function() {
            $(this).carousel('prev');
            });
         $("#mycarousel").swipeleft(function() {
            $(this).carousel('next');
       });
    });
  </script>

  
       <style type="text/css">
         div.admonition {
           background-color: whiteSmoke;
           border: 1px solid #bababa;
         }
       </style>
      </head>
    
  <body role="document">
<header id="header">
      <div class="navbar navbar-inverse" role="banner">
          <div class="container">
              <div class="navbar-header">
                  <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#headernavbar">
                      <span class="sr-only">Toggle navigation</span>
                      <span class="icon-bar"></span>
                      <span class="icon-bar"></span>
                      <span class="icon-bar"></span>
                  </button>

                  <a class="navbar-brand" href="http://fenicsproject.org/index.html">
                      <h1><img src="_static/fenics_banner.png" alt="FEniCS Project Logo" class="img-responsive center-block banner-image"></h1>
                  </a>

              </div>
              <div class="collapse navbar-collapse" id="headernavbar">
                <ul class="nav navbar-nav navbar-right">
                    <li><a href="._ftut1002.html" title="Previous page">Prev</a></li>
                    <li><a href="._ftut1004.html" title="Next page">Next</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/index.html">Home</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/about/" title="Find out more about the FEniCS project">About</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/download/" title="Obtain the FEniCS project">Download</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/documentation/" title="Learn how to use the FEniCS project">Documentation</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/contributing/" title="Learn how to contribute to the FEniCS project">Contributing</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/citing/" title="Learn how to cite the FEniCS project">Citing</a></li>
                    <li class="page_item"><a href="http://fenicsproject.org/support/" title="Where to go for more help">Support</a></li>
                  </ul>
              </div>
          </div>
      </div>
  </header>

<div class="container">
  <div class="row">
    <div class="col-md-12">
      
  <div class="section" id="fundamentals-solving-the-poisson-equation">
<span id="ch-fundamentals"></span><h1>Fundamentals: Solving the Poisson equation<a class="headerlink" href="#fundamentals-solving-the-poisson-equation" title="Permalink to this headline">¶</a></h1>
<blockquote>
<div>The goal of this chapter is to show how the Poisson equation, the
most basic of all PDEs, can be quickly solved with a few lines
of FEniCS code. We introduce the most
fundamental FEniCS objects such as <code class="docutils literal"><span class="pre">Mesh</span></code>, <code class="docutils literal"><span class="pre">Function</span></code>,
<code class="docutils literal"><span class="pre">FunctionSpace</span></code>, <code class="docutils literal"><span class="pre">TrialFunction</span></code>,
and <code class="docutils literal"><span class="pre">TestFunction</span></code>, and learn how to write a basic PDE solver,
including how to formulate the mathematical variational problem,
apply boundary conditions, call the FEniCS solver, and plot
the solution.</div></blockquote>
<div class="section" id="mathematical-problem-formulation">
<span id="ftut-poisson1-bvp"></span><h2>Mathematical problem formulation<a class="headerlink" href="#mathematical-problem-formulation" title="Permalink to this headline">¶</a></h2>
<p id="index-0">Many books on programming languages start with a &#8220;Hello, World!&#8221;
program. Readers are curious to know how fundamental tasks are
expressed in the language, and printing a text to the screen can be
such a task. In the world of <em>finite element methods for PDEs</em>, the
most fundamental task must be to solve the Poisson equation. Our
counterpart to the classical &#8220;Hello, World!&#8221; program therefore
solves the following boundary-value problem:</p>
<div class="math" id="eq-ftut-poisson1">
\[\tag{1}
- \nabla^2 u(\boldsymbol{x}) = f(\boldsymbol{x}),\quad \boldsymbol{x}\mbox{ in } \Omega,\]</div>
<div class="math" id="eq-ch-poisson0-bc">
\[\tag{2}
u(\boldsymbol{x}) = u_{_\mathrm{D}}(\boldsymbol{x}),\quad \boldsymbol{x}\mbox{ on } \partial \Omega{\thinspace .}\]</div>
<p>Here, <span class="math">\(u = u(\boldsymbol{x})\)</span> is the unknown function, <span class="math">\(f = f(\boldsymbol{x})\)</span> is a
prescribed function, <span class="math">\(\nabla^2\)</span> is the Laplace operator
(often written as <span class="math">\(\Delta\)</span>), <span class="math">\(\Omega\)</span> is the spatial domain, and
<span class="math">\(\partial\Omega\)</span> is the boundary of <span class="math">\(\Omega\)</span>. The Poisson problem,
including both the PDE <span class="math">\(-\nabla^2 u = f\)</span> and the boundary condition
<span class="math">\(u = u_{_\mathrm{D}}\)</span> on <span class="math">\(\partial \Omega\)</span>, is an example of a <em>boundary-value
problem</em>, which must be precisely stated before
it makes sense to start solving it with FEniCS.</p>
<p>In two space dimensions with coordinates <span class="math">\(x\)</span> and <span class="math">\(y\)</span>, we can write out
the Poisson equation as</p>
<div class="math" id="eq-auto1">
\[\tag{3}
- {\partial^2 u\over\partial x^2} -
    {\partial^2 u\over\partial y^2} = f(x,y){\thinspace .}\]</div>
<p>The unknown <span class="math">\(u\)</span> is now a function of two variables, <span class="math">\(u = u(x,y)\)</span>, defined
over a two-dimensional domain <span class="math">\(\Omega\)</span>.</p>
<p>The Poisson equation arises in numerous physical contexts, including
heat conduction, electrostatics, diffusion of substances, twisting of
elastic rods, inviscid fluid flow, and water waves. Moreover, the
equation appears in numerical splitting strategies for more complicated
systems of PDEs, in particular the Navier - Stokes equations.</p>
<p>Solving a boundary-value problem such as the Poisson equation in
FEniCS consists of the following steps:</p>
<blockquote>
<div><ol class="arabic simple">
<li>Identify the computational domain (<span class="math">\(\Omega\)</span>), the PDE, its
boundary conditions, and source terms (<span class="math">\(f\)</span>).</li>
<li>Reformulate the PDE as a finite element variational problem.</li>
<li>Write a Python program which defines the computational domain,
the variational problem, the boundary conditions, and source
terms, using the corresponding FEniCS abstractions.</li>
<li>Call FEniCS to solve the boundary-value problem and, optionally,
extend the program
to compute derived quantities such as fluxes and averages, and
visualize the results.</li>
</ol>
</div></blockquote>
<p>We shall now go through steps 2 - 4 in detail. The key feature of
FEniCS is that steps 3 and 4 result in fairly short code, while a
similar program in most other software frameworks for PDEs require
much more code and technically difficult programming.</p>
<div class="admonition-what-makes-fenics-attractive admonition">
<p class="first admonition-title">What makes FEniCS attractive</p>
<p class="last">Although many software frameworks have a really elegant
&#8220;Hello, World!&#8221; example for the
Poisson equation, FEniCS is to our knowledge the only framework where
the code stays compact and nice, very close to the mathematical
formulation, even when the mathematical and algorithmic complexity
increases and when moving from a laptop to a high-performance
compute server (cluster).</p>
</div>
<div class="section" id="finite-element-variational-formulation">
<span id="ch-poisson0-varform"></span><h3>Finite element variational formulation<a class="headerlink" href="#finite-element-variational-formulation" title="Permalink to this headline">¶</a></h3>
<p id="index-1">FEniCS is based on the finite element method, which is a general and
efficient mathematical machinery for the numerical solution of
PDEs. The starting point for the finite element methods is a PDE
expressed in <em>variational form</em>. Readers who are not familiar with
variational problems will get a very brief introduction to the topic
in this tutorial, but reading a proper book on the finite element
method in addition is encouraged. The section <a class="reference internal" href="._ftut1002.html#ftut-fembooks"><span>The finite element method</span></a> contains
a list of recommended books. Experience shows that you can work with
FEniCS as a tool to solve PDEs even without thorough knowledge of
the finite element method, as long as you get somebody to help you
with formulating the PDE as a variational problem.</p>
<span class="target" id="index-2"></span><p id="index-3">The basic recipe for turning a PDE into a variational problem is to
multiply the PDE by a function <span class="math">\(v\)</span>, integrate the resulting equation
over the domain <span class="math">\(\Omega\)</span>, and perform integration by parts of terms
with second-order derivatives. The function <span class="math">\(v\)</span> which multiplies the
PDE is called a <em>test function</em>. The unknown function <span class="math">\(u\)</span> to be
approximated is referred to as a <em>trial function</em>. The terms trial and
test functions are used in FEniCS programs too. The trial and test
functions belong to certain so-called <em>function spaces</em> that specify
the properties of the functions.</p>
<p id="index-4">In the present case, we first multiply the Poisson equation
by the test function <span class="math">\(v\)</span> and integrate over <span class="math">\(\Omega\)</span>:</p>
<div class="math" id="eq-ch-poisson0-multbyv">
\[\tag{4}
-\int_\Omega (\nabla^2 u)v {\, \mathrm{d}x} = \int_\Omega fv {\, \mathrm{d}x}{\thinspace .}\]</div>
<p>We here let <span class="math">\({\, \mathrm{d}x}\)</span> denote the differential element for integration over
the domain <span class="math">\(\Omega\)</span>. We will later let <span class="math">\({\, \mathrm{d}s}\)</span> denote the differential
element for integration over the boundary of <span class="math">\(\Omega\)</span>.</p>
<p>A common rule when we derive variational formulations is that we try
to keep the order of the derivatives of <span class="math">\(u\)</span> and <span class="math">\(v\)</span> as small as
possible. Here, we have a second-order spatial derivative of <span class="math">\(u\)</span>,
which can be transformed to a first-derivative of <span class="math">\(u\)</span> and <span class="math">\(v\)</span> by
applying the technique of <a class="reference external" href="https://en.wikipedia.org/wiki/Integration_by_parts">integration by parts</a>. The formula
reads</p>
<div class="math" id="eq-ch-poisson0-eqbyparts">
\[\tag{5}
-\int_\Omega (\nabla^2 u)v {\, \mathrm{d}x}
    = \int_\Omega\nabla u\cdot\nabla v {\, \mathrm{d}x} - \int_{\partial\Omega}{\partial u\over
    \partial n}v {\, \mathrm{d}s} ,\]</div>
<p>where <span class="math">\(\frac{\partial u}{\partial n} = \nabla u \cdot n\)</span> is the
derivative of <span class="math">\(u\)</span> in the outward normal direction <span class="math">\(n\)</span> on the
boundary.</p>
<p>Another feature of variational formulations is that
the test function <span class="math">\(v\)</span> is required to vanish on the parts of
the boundary where the solution <span class="math">\(u\)</span> is known (the book <a class="reference internal" href="._ftut1006.html#ref14" id="id1">[Ref14]</a> explains in detail why this requirement is necessary).
In the present
problem, this means that <span class="math">\(v=0\)</span> on the whole boundary <span class="math">\(\partial\Omega\)</span>.
The second term on the right-hand side of
<a class="reference internal" href="#eq-ch-poisson0-eqbyparts"><span>(5)</span></a> therefore vanishes. From
<a class="reference internal" href="#eq-ch-poisson0-multbyv"><span>(4)</span></a> and <a class="reference internal" href="#eq-ch-poisson0-eqbyparts"><span>(5)</span></a> it
follows that</p>
<div class="math" id="eq-ch-poisson0-weak1">
\[\tag{6}
\int_\Omega\nabla u\cdot\nabla v {\, \mathrm{d}x} = \int_\Omega fv {\, \mathrm{d}x}{\thinspace .}\]</div>
<p>If we require that this equation holds for all test functions <span class="math">\(v\)</span> in
some suitable space <span class="math">\(\hat V\)</span>, the so-called <em>test space</em>, we obtain a
well-defined mathematical problem that uniquely determines the
solution <span class="math">\(u\)</span> which lies in some (possibly different) function space
<span class="math">\(V\)</span>, the so-called <em>trial space</em>.  We refer to
<a class="reference internal" href="#eq-ch-poisson0-weak1"><span>(6)</span></a> as the <em>weak form</em> or <em>variational form</em> of
the original boundary-value problem
<a class="reference internal" href="#eq-ftut-poisson1"><span>(1)</span></a>&#8211;<a class="reference internal" href="#eq-ch-poisson0-bc"><span>(2)</span></a>.</p>
<p>The proper statement of
our variational problem now goes as follows:
find <span class="math">\(u \in V\)</span> such that</p>
<div class="math" id="eq-ch-poisson0-var">
\[\tag{7}
\int_{\Omega} \nabla u \cdot \nabla v {\, \mathrm{d}x} =
      \int_{\Omega} fv {\, \mathrm{d}x}
      \quad \forall v \in \hat{V}{\thinspace .}\]</div>
<p>The trial and test spaces <span class="math">\(V\)</span> and <span class="math">\(\hat V\)</span> are in the present
problem defined as</p>
<div class="math">
\[\begin{split}\begin{align*}
     V      &amp;= \{v \in H^1(\Omega) : v = u_{_\mathrm{D}} \mbox{ on } \partial\Omega\}, \\
    \hat{V} &amp;= \{v \in H^1(\Omega) : v = 0 \mbox{ on } \partial\Omega\}{\thinspace .}
\end{align*}\end{split}\]</div>
<p>In short, <span class="math">\(H^1(\Omega)\)</span> is the mathematically well-known Sobolev space
containing functions <span class="math">\(v\)</span> such that <span class="math">\(v^2\)</span> and <span class="math">\(|\nabla v|^2\)</span> have
finite integrals over <span class="math">\(\Omega\)</span> (essentially meaning that the functions
are continuous). The solution of the underlying PDE must lie in a
function space where the derivatives are also continuous, but the
Sobolev space <span class="math">\(H^1(\Omega)\)</span> allows functions with discontinuous
derivatives. This weaker continuity requirement of <span class="math">\(u\)</span> in the
variational statement <a class="reference internal" href="#eq-ch-poisson0-var"><span>(7)</span></a>, as a result of the
integration by parts, has great practical consequences when it comes
to constructing finite element function spaces. In particular, it
allows the use of piecewise polynomial function spaces; i.e., function
spaces constructed by stitching together polynomial functions on simple
domains such as intervals, triangles, or tetrahedrons.</p>
<p>The variational problem <a class="reference internal" href="#eq-ch-poisson0-var"><span>(7)</span></a> is a <em>continuous
problem</em>: it defines the solution <span class="math">\(u\)</span> in the infinite-dimensional
function space <span class="math">\(V\)</span>. The finite element method for the Poisson equation
finds an approximate solution of the variational problem
<a class="reference internal" href="#eq-ch-poisson0-var"><span>(7)</span></a> by replacing the infinite-dimensional function
spaces <span class="math">\(V\)</span> and <span class="math">\(\hat{V}\)</span> by <em>discrete</em> (finite-dimensional) trial and
test spaces <span class="math">\(V_h\subset{V}\)</span> and <span class="math">\(\hat{V}_h\subset\hat{V}\)</span>. The discrete variational problem reads: find <span class="math">\(u_h \in
V_h \subset V\)</span> such that</p>
<div class="math" id="eq-ch-poisson0-vard">
\[\tag{8}
\int_{\Omega} \nabla u_h \cdot \nabla v {\, \mathrm{d}x} =
      \int_{\Omega} fv {\, \mathrm{d}x}
      \quad \forall v \in \hat{V}_h \subset \hat{V}{\thinspace .}\]</div>
<p>This variational problem, together with a suitable definition of the
function spaces <span class="math">\(V_h\)</span> and <span class="math">\(\hat{V}_h\)</span>, uniquely define our approximate
numerical solution of Poisson&#8217;s equation <a class="reference internal" href="#eq-ftut-poisson1"><span>(1)</span></a>. Note
that the boundary conditions are encoded as part of the trial and test
spaces. The mathematical framework may seem complicated at first
glance, but the good news is that the finite element variational
problem <a class="reference internal" href="#eq-ch-poisson0-vard"><span>(8)</span></a> looks the same as the continuous
variational problem <a class="reference internal" href="#eq-ch-poisson0-var"><span>(7)</span></a>, and FEniCS can
automatically solve variational problems like <a class="reference internal" href="#eq-ch-poisson0-vard"><span>(8)</span></a>!</p>
<div class="admonition-what-we-mean-by-the-notation-math-u-and-math-v admonition">
<p class="first admonition-title">What we mean by the notation <span class="math">\(u\)</span> and <span class="math">\(V\)</span></p>
<p class="last">The mathematics literature on variational problems writes <span class="math">\(u_h\)</span> for
the solution of the discrete problem and <span class="math">\(u\)</span> for the solution of the
continuous problem. To obtain (almost) a one-to-one relationship
between the mathematical formulation of a problem and the
corresponding FEniCS program, we shall drop the subscript <span class="math">\(_h\)</span> and use
<span class="math">\(u\)</span> for the solution of the discrete problem.
We will use <span class="math">\({u_{\small\mbox{e}}}\)</span> for the exact
solution of the continuous problem, <em>if</em> we need to explicitly distinguish
between the two. Similarly, we will let <span class="math">\(V\)</span> denote the discrete finite
element function space in which we seek our solution.</p>
</div>
</div>
<div class="section" id="abstract-finite-element-variational-formulation">
<span id="ch-poisson0-abstrat"></span><h3>Abstract finite element variational formulation<a class="headerlink" href="#abstract-finite-element-variational-formulation" title="Permalink to this headline">¶</a></h3>
<p id="index-5">It turns out to be convenient to introduce the following canonical
notation for variational problems: find <span class="math">\(u\in V\)</span> such that</p>
<div class="math" id="eq-auto2">
\[\tag{9}
a(u, v) = L(v) \quad \forall v \in \hat{V}.\]</div>
<p>For the Poisson equation, we have:</p>
<div class="math" id="eq-ch-poisson0-vard-a">
\[\tag{10}
a(u, v) = \int_{\Omega} \nabla u \cdot \nabla v {\, \mathrm{d}x},\]</div>
<div class="math" id="eq-ch-poisson0-vard-l">
\[\tag{11}
L(v) = \int_{\Omega} fv {\, \mathrm{d}x}{\thinspace .}\]</div>
<p>From the mathematics literature, <span class="math">\(a(u,v)\)</span> is known as a <em>bilinear
form</em> and <span class="math">\(L(v)\)</span> as a <em>linear form</em>.  We shall, in every linear problem
we solve, identify the terms with the unknown <span class="math">\(u\)</span> and collect them in
<span class="math">\(a(u,v)\)</span>, and similarly collect all terms with only known functions in
<span class="math">\(L(v)\)</span>. The formulas for <span class="math">\(a\)</span> and <span class="math">\(L\)</span> can then be expressed directly in
our FEniCS programs.</p>
<p>To solve a linear PDE in FEniCS, such as the Poisson equation, a user
thus needs to perform only two steps:</p>
<blockquote>
<div><ul class="simple">
<li>Choose the finite element spaces <span class="math">\(V\)</span> and <span class="math">\(\hat V\)</span> by specifying
the domain (the mesh) and the type of function space (polynomial
degree and type).</li>
<li>Express the PDE as a (discrete) variational problem: find <span class="math">\(u\in V\)</span>
such that <span class="math">\(a(u,v) = L(v)\)</span> for all <span class="math">\(v\in \hat{V}\)</span>.</li>
</ul>
</div></blockquote>
</div>
<div class="section" id="choosing-a-test-problem">
<span id="ch-poisson0-testproblem"></span><h3>Choosing a test problem<a class="headerlink" href="#choosing-a-test-problem" title="Permalink to this headline">¶</a></h3>
<p>The Poisson problem <a class="reference internal" href="#eq-ftut-poisson1"><span>(1)</span></a>&#8211;<a class="reference internal" href="#eq-ch-poisson0-bc"><span>(2)</span></a> has so
far featured a general domain <span class="math">\(\Omega\)</span> and general functions <span class="math">\(u_{_\mathrm{D}}\)</span> for
the boundary conditions and <span class="math">\(f\)</span> for the right-hand side. For our first
implementation we will need to make specific choices for <span class="math">\(\Omega\)</span>,
<span class="math">\(u_{_\mathrm{D}}\)</span>, and <span class="math">\(f\)</span>.  It will be wise to construct a problem with a known
analytical solution so that we can easily check that the computed
solution is correct. Solutions that are lower-order polynomials are
primary candidates. Standard finite element function spaces of degree
<span class="math">\(r\)</span> will exactly reproduce polynomials of degree <span class="math">\(r\)</span>. And piecewise
linear elements (<span class="math">\(r=1\)</span>) are able to exactly reproduce a quadratic
polynomial on a uniformly partitioned mesh. This important result can
be used to verify our implementation. We just manufacture some
quadratic function in 2D as the exact solution, say</p>
<div class="math" id="eq-ch-poisson0-impl-uex">
<span id="index-6"></span>\[\tag{12}
\
    {u_{\small\mbox{e}}}(x,y) = 1 +x^2 + 2y^2{\thinspace .}\]</div>
<p>By inserting <a class="reference internal" href="#eq-ch-poisson0-impl-uex"><span>(12)</span></a> into the Poisson equation
<a class="reference internal" href="#eq-ftut-poisson1"><span>(1)</span></a>, we find that <span class="math">\({u_{\small\mbox{e}}}(x,y)\)</span> is a solution if</p>
<div class="math">
\[f(x,y) = -6,\quad u_{_\mathrm{D}}(x,y)={u_{\small\mbox{e}}}(x,y)=1 + x^2 + 2y^2,\]</div>
<p>regardless of the shape of the domain as long as <span class="math">\({u_{\small\mbox{e}}}\)</span> is prescribed along
the boundary. We choose here, for simplicity,
the domain to be the unit square,</p>
<div class="math">
\[\Omega = [0,1]\times [0,1] {\thinspace .}\]</div>
<p>This simple but very powerful method for constructing test problems is
called the <em>method of manufactured solutions</em>: pick a simple
expression for the exact solution, plug it into the equation to obtain
the right-hand side (source term <span class="math">\(f\)</span>), then solve the equation with
this right-hand side and using the exact solution as a boundary
condition, and try to reproduce the exact solution.</p>
<span class="target" id="index-7"></span><span class="target" id="index-8"></span><div class="admonition-tip-try-to-verify-your-code-with-exact-numerical-solutions admonition" id="index-9">
<p class="first admonition-title">Tip: Try to verify your code with exact numerical solutions</p>
<p class="last">A common approach to testing the implementation of a numerical method
is to compare the numerical
solution with an exact analytical solution of the test problem and
conclude that the program works if the error is &#8220;small enough&#8221;.
Unfortunately, it is impossible to tell if an error of size <span class="math">\(10^{-5}\)</span> on a
<span class="math">\(20\times 20\)</span> mesh of linear elements is the expected (in)accuracy of the
numerical approximation or if the error also contains the effect of a
bug in the code. All we usually know about the numerical error is its
<em>asymptotic properties</em>, for instance that it is proportional to <span class="math">\(h^2\)</span>
if <span class="math">\(h\)</span> is the size of a cell in the mesh. Then we compare the
error on meshes with different <span class="math">\(h\)</span>-values to see if the asymptotic
behavior is correct. This is a very powerful verification
technique and is explained in detail in the section <a class="reference internal" href="._ftut1006.html#ch-poisson0-convrates"><span>Computing convergence rates          (1)</span></a>.
However, if we have a test problem for which
we know that there should be no approximation errors, we know that
the analytical solution of the PDE problem should be reproduced to
machine precision by the program. That is why we emphasize this kind
of test problems throughout this tutorial. Typically, elements of
degree <span class="math">\(r\)</span> can reproduce polynomials of degree <span class="math">\(r\)</span> exactly, so this
is the starting point for constructing a solution without numerical
approximation errors.</p>
</div>
</div>
</div>
<div class="section" id="fenics-implementation-1">
<span id="ch-poisson0-impl"></span><h2>FEniCS implementation<a class="headerlink" href="#fenics-implementation-1" title="Permalink to this headline">¶</a></h2>
<div class="section" id="the-complete-program">
<h3>The complete program<a class="headerlink" href="#the-complete-program" title="Permalink to this headline">¶</a></h3>
<p>A FEniCS program for solving our test problem for the Poisson equation
in 2D with the given choices of <span class="math">\(\Omega\)</span>, <span class="math">\(u_{_\mathrm{D}}\)</span>, and <span class="math">\(f\)</span> may look as
follows:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">fenics</span> <span class="kn">import</span> <span class="o">*</span>

<span class="c1"># Create mesh and define function space</span>
<span class="n">mesh</span> <span class="o">=</span> <span class="n">UnitSquareMesh</span><span class="p">(</span><span class="mi">8</span><span class="p">,</span> <span class="mi">8</span><span class="p">)</span>
<span class="n">V</span> <span class="o">=</span> <span class="n">FunctionSpace</span><span class="p">(</span><span class="n">mesh</span><span class="p">,</span> <span class="s1">&#39;P&#39;</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>

<span class="c1"># Define boundary condition</span>
<span class="n">u_D</span> <span class="o">=</span> <span class="n">Expression</span><span class="p">(</span><span class="s1">&#39;1 + x[0]*x[0] + 2*x[1]*x[1]&#39;</span><span class="p">,</span> <span class="n">degree</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>

<span class="k">def</span> <span class="nf">boundary</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">on_boundary</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">on_boundary</span>

<span class="n">bc</span> <span class="o">=</span> <span class="n">DirichletBC</span><span class="p">(</span><span class="n">V</span><span class="p">,</span> <span class="n">u_D</span><span class="p">,</span> <span class="n">boundary</span><span class="p">)</span>

<span class="c1"># Define variational problem</span>
<span class="n">u</span> <span class="o">=</span> <span class="n">TrialFunction</span><span class="p">(</span><span class="n">V</span><span class="p">)</span>
<span class="n">v</span> <span class="o">=</span> <span class="n">TestFunction</span><span class="p">(</span><span class="n">V</span><span class="p">)</span>
<span class="n">f</span> <span class="o">=</span> <span class="n">Constant</span><span class="p">(</span><span class="o">-</span><span class="mf">6.0</span><span class="p">)</span>
<span class="n">a</span> <span class="o">=</span> <span class="n">dot</span><span class="p">(</span><span class="n">grad</span><span class="p">(</span><span class="n">u</span><span class="p">),</span> <span class="n">grad</span><span class="p">(</span><span class="n">v</span><span class="p">))</span><span class="o">*</span><span class="n">dx</span>
<span class="n">L</span> <span class="o">=</span> <span class="n">f</span><span class="o">*</span><span class="n">v</span><span class="o">*</span><span class="n">dx</span>

<span class="c1"># Compute solution</span>
<span class="n">u</span> <span class="o">=</span> <span class="n">Function</span><span class="p">(</span><span class="n">V</span><span class="p">)</span>
<span class="n">solve</span><span class="p">(</span><span class="n">a</span> <span class="o">==</span> <span class="n">L</span><span class="p">,</span> <span class="n">u</span><span class="p">,</span> <span class="n">bc</span><span class="p">)</span>

<span class="c1"># Plot solution and mesh</span>
<span class="n">plot</span><span class="p">(</span><span class="n">u</span><span class="p">)</span>
<span class="n">plot</span><span class="p">(</span><span class="n">mesh</span><span class="p">)</span>

<span class="c1"># Save solution to file in VTK format</span>
<span class="n">vtkfile</span> <span class="o">=</span> <span class="n">File</span><span class="p">(</span><span class="s1">&#39;poisson/solution.pvd&#39;</span><span class="p">)</span>
<span class="n">vtkfile</span> <span class="o">&lt;&lt;</span> <span class="n">u</span>

<span class="c1"># Compute error in L2 norm</span>
<span class="n">error_L2</span> <span class="o">=</span> <span class="n">errornorm</span><span class="p">(</span><span class="n">u_D</span><span class="p">,</span> <span class="n">u</span><span class="p">,</span> <span class="s1">&#39;L2&#39;</span><span class="p">)</span>

<span class="c1"># Compute maximum error at vertices</span>
<span class="n">vertex_values_u_D</span> <span class="o">=</span> <span class="n">u_D</span><span class="o">.</span><span class="n">compute_vertex_values</span><span class="p">(</span><span class="n">mesh</span><span class="p">)</span>
<span class="n">vertex_values_u</span> <span class="o">=</span> <span class="n">u</span><span class="o">.</span><span class="n">compute_vertex_values</span><span class="p">(</span><span class="n">mesh</span><span class="p">)</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="n">error_max</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">vertex_values_u_D</span> <span class="o">-</span> <span class="n">vertex_values_u</span><span class="p">))</span>

<span class="c1"># Print errors</span>
<span class="k">print</span><span class="p">(</span><span class="s1">&#39;error_L2  =&#39;</span><span class="p">,</span> <span class="n">error_L2</span><span class="p">)</span>
<span class="k">print</span><span class="p">(</span><span class="s1">&#39;error_max =&#39;</span><span class="p">,</span> <span class="n">error_max</span><span class="p">)</span>

<span class="c1"># Hold plot</span>
<span class="n">interactive</span><span class="p">()</span>
</pre></div>
</div>
<p>This example program can be found in the file <a class="reference external" href="https://fenicsproject.org/pub/tutorial/python/vol1/ft01_poisson.py">ft01_poisson.py</a>.</p>
</div>
<div class="section" id="running-the-program">
<span id="ch-poisson0-impl-run"></span><span id="index-10"></span><h3>Running the program<a class="headerlink" href="#running-the-program" title="Permalink to this headline">¶</a></h3>
<p>The FEniCS program must be available in a plain text file, written with a
text editor such as Atom, Sublime Text, Emacs, Vim, or similar.
There are several ways to run a Python program like
<a class="reference external" href="https://fenicsproject.org/pub/tutorial/python/vol1/ft01_poisson.py">ft01_poisson.py</a>:</p>
<blockquote>
<div><ul class="simple">
<li>Use a terminal window.</li>
<li>Use an integrated development environment (IDE), e.g., Spyder.</li>
<li>Use a Jupyter notebook.</li>
</ul>
</div></blockquote>
<div class="section" id="terminal-window">
<h4>Terminal window<a class="headerlink" href="#terminal-window" title="Permalink to this headline">¶</a></h4>
<p id="index-11">Open a terminal
window, move to the directory containing the program and type the
following command:</p>
<div class="highlight-text"><div class="highlight"><pre><span></span>Terminal&gt; python ft01_poisson.py
</pre></div>
</div>
<p>Note that this command must be run in a FEniCS-enabled terminal. For
users of the FEniCS Docker containers, this means that you must type
this command after you have started a FEniCS session using
<code class="docutils literal"><span class="pre">fenicsproject</span> <span class="pre">run</span></code> or <code class="docutils literal"><span class="pre">fenicsproject</span> <span class="pre">start</span></code>.</p>
<p>When running the above command, FEniCS will run the program to compute
the approximate solution <span class="math">\(u\)</span>. The approximate solution <span class="math">\(u\)</span> will be
compared to the exact solution <span class="math">\({u_{\small\mbox{e}}} = u_{_\mathrm{D}}\)</span> and the error in the <span class="math">\(L^2\)</span> and
maximum norms will be printed. Since we know that our approximate
solution should reproduce the exact solution to within machine
precision, this error should be small, something on the order of
<span class="math">\(10^{-15}\)</span>. If plotting is enabled in your FEniCS installation,
then a window with a simple plot of the solution will appear as
in Figure <a class="reference internal" href="#fig-poisson-plot"><span>Plot of the mesh and the solution for the Poisson problem created using the built-in FEniCS visualization tool (``plot`` command)</span></a>.</p>
</div>
<div class="section" id="spyder">
<h4>Spyder<a class="headerlink" href="#spyder" title="Permalink to this headline">¶</a></h4>
<p id="index-12">Many prefer to work in an integrated development environment that
provides an editor for programming, a window for executing code, a
window for inspecting objects, etc. Just open the file
<a class="reference external" href="https://fenicsproject.org/pub/tutorial/python/vol1/ft01_poisson.py">ft01_poisson.py</a>
and press the play button to run it. We refer to the Spyder tutorial
to learn more about working in the Spyder environment. Spyder is
highly recommended if you are used to working in the <em>graphical</em>
MATLAB environment.</p>
</div>
<div class="section" id="jupyter-notebooks">
<h4>Jupyter notebooks<a class="headerlink" href="#jupyter-notebooks" title="Permalink to this headline">¶</a></h4>
<p id="index-13">Notebooks make it possible to mix text and executable code in the same
document, but you can also just use it to run programs in a web
browser. Run the command <code class="docutils literal"><span class="pre">jupyter</span> <span class="pre">notebook</span></code> from a terminal window,
find the <strong>New</strong> pulldown menu in the upper right corner of the GUI,
choose a new notebook in Python 2 or 3, write <code class="docutils literal"><span class="pre">%load</span>
<span class="pre">ft01_poisson.py</span></code> in the blank cell of this notebook, then press
Shift+Enter to execute the cell.  The file <a class="reference external" href="https://fenicsproject.org/pub/tutorial/python/vol1/ft01_poisson.py">ft01_poisson.py</a> will then be loaded into the
notebook.  Re-execute the cell (Shift+Enter) to run the program. You
may divide the entire program into several cells to examine
intermediate results: place the cursor where you want to split the
cell and choose <strong>Edit - Split Cell</strong>. For users of the FEniCS Docker
images, run the <code class="docutils literal"><span class="pre">fenicsproject</span> <span class="pre">notebook</span></code> command and follow the
instructions. To enable plotting, make sure to run the command
<code class="docutils literal"><span class="pre">%matplotlib</span> <span class="pre">inline</span></code> inside the notebook.</p>
</div>
</div>
</div>
<div class="section" id="dissection-of-the-program">
<span id="ch-poisson0-impl-dissect"></span><h2>Dissection of the program<a class="headerlink" href="#dissection-of-the-program" title="Permalink to this headline">¶</a></h2>
<p>We shall now dissect our FEniCS program in detail.  The listed FEniCS
program defines a finite element mesh, a finite element function space
<span class="math">\(V\)</span> on this mesh, boundary conditions for <span class="math">\(u\)</span> (the function <span class="math">\(u_{_\mathrm{D}}\)</span>),
and the bilinear and linear forms <span class="math">\(a(u,v)\)</span> and <span class="math">\(L(v)\)</span>. Thereafter, the
solution <span class="math">\(u\)</span> is computed. At the end of the program, we compare the
numerical and the exact solutions. We also plot the solution using the
<code class="docutils literal"><span class="pre">plot</span></code> command and save the solution to a file for external
postprocessing.</p>
<div class="section" id="the-important-first-line">
<h3>The important first line<a class="headerlink" href="#the-important-first-line" title="Permalink to this headline">¶</a></h3>
<p>The first line in the program,</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">fenics</span> <span class="kn">import</span> <span class="o">*</span>
</pre></div>
</div>
<p>imports the key classes <code class="docutils literal"><span class="pre">UnitSquareMesh</span></code>, <code class="docutils literal"><span class="pre">FunctionSpace</span></code>, <code class="docutils literal"><span class="pre">Function</span></code>,
and so forth, from the FEniCS library.  All FEniCS programs for
solving PDEs by the finite element method normally start with this
line.</p>
<span class="target" id="index-14"></span></div>
<div class="section" id="generating-simple-meshes">
<span id="index-15"></span><h3>Generating simple meshes<a class="headerlink" href="#generating-simple-meshes" title="Permalink to this headline">¶</a></h3>
<p>The statement</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">mesh</span> <span class="o">=</span> <span class="n">UnitSquareMesh</span><span class="p">(</span><span class="mi">8</span><span class="p">,</span> <span class="mi">8</span><span class="p">)</span>
</pre></div>
</div>
<p>defines a uniform finite element mesh over the unit square
<span class="math">\([0,1]\times [0,1]\)</span>. The mesh consists of <em>cells</em>, which in 2D are triangles
with straight sides. The parameters 8 and 8 specify that the square
should be divided into <span class="math">\(8\times 8\)</span> rectangles, each divided into a pair of
triangles. The total number of triangles (cells) thus becomes
128. The total number of vertices in the mesh is <span class="math">\(9\cdot 9=81\)</span>.
In later chapters, you will learn how to generate more complex meshes.</p>
<span class="target" id="index-16"></span><span class="target" id="index-17"></span><span class="target" id="index-18"></span></div>
<div class="section" id="defining-the-finite-element-function-space">
<span id="index-19"></span><h3>Defining the finite element function space<a class="headerlink" href="#defining-the-finite-element-function-space" title="Permalink to this headline">¶</a></h3>
<span class="target" id="index-20"></span><p id="index-21">Once the mesh has been created, we can create a finite element
function space <code class="docutils literal"><span class="pre">V</span></code>:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">V</span> <span class="o">=</span> <span class="n">FunctionSpace</span><span class="p">(</span><span class="n">mesh</span><span class="p">,</span> <span class="s1">&#39;P&#39;</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
</pre></div>
</div>
<p>The second argument <code class="docutils literal"><span class="pre">'P'</span></code> specifies the type of element. The type of
element here is <span class="math">\(\mathsf{P}\)</span>, implying the standard Lagrange family of
elements. You may also use <code class="docutils literal"><span class="pre">'Lagrange'</span></code> to specify this type of
element. FEniCS supports all simplex element families and the notation
defined in the <a class="reference external" href="https://www.femtable.org">Periodic Table of the Finite Elements</a> <a class="reference internal" href="._ftut1006.html#ref26" id="id2">[Ref26]</a>.</p>
<p id="index-22">The third argument <code class="docutils literal"><span class="pre">1</span></code> specifies the degree of the finite element.  In
this case, the standard <span class="math">\(\mathsf{P}_1\)</span> linear Lagrange element, which
is a triangle with nodes at the three vertices. Some finite element
practitioners refer to this element as the &#8220;linear triangle&#8221;. The
computed solution <span class="math">\(u\)</span> will be continuous across elements and linearly
varying in <span class="math">\(x\)</span> and <span class="math">\(y\)</span> inside each element. Higher-degree polynomial
approximations over each cell are trivially obtained by increasing the
third parameter to <code class="docutils literal"><span class="pre">FunctionSpace</span></code>, which will then generate function
spaces of type <span class="math">\(\mathsf{P}_2\)</span>, <span class="math">\(\mathsf{P}_3\)</span>, and so forth.  Changing
the second parameter to <code class="docutils literal"><span class="pre">'DP'</span></code> creates a function space for
discontinuous Galerkin methods.</p>
<span class="target" id="index-23"></span><span class="target" id="index-24"></span><span class="target" id="index-25"></span></div>
<div class="section" id="defining-the-trial-and-test-functions">
<span id="index-26"></span><h3>Defining the trial and test functions<a class="headerlink" href="#defining-the-trial-and-test-functions" title="Permalink to this headline">¶</a></h3>
<p>In mathematics, we distinguish between the trial and test spaces <span class="math">\(V\)</span>
and <span class="math">\(\hat{V}\)</span>. The only difference in the present problem is the
boundary conditions. In FEniCS we do not specify the boundary
conditions as part of the function space, so it is sufficient to work
with one common space <code class="docutils literal"><span class="pre">V</span></code> for both the trial and test functions in the
program:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">u</span> <span class="o">=</span> <span class="n">TrialFunction</span><span class="p">(</span><span class="n">V</span><span class="p">)</span>
<span class="n">v</span> <span class="o">=</span> <span class="n">TestFunction</span><span class="p">(</span><span class="n">V</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="section" id="defining-the-boundary-conditions">
<span id="index-27"></span><h3>Defining the boundary conditions<a class="headerlink" href="#defining-the-boundary-conditions" title="Permalink to this headline">¶</a></h3>
<p>The next step is to specify the boundary condition: <span class="math">\(u=u_{_\mathrm{D}}\)</span> on
<span class="math">\(\partial\Omega\)</span>. This is done by</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">bc</span> <span class="o">=</span> <span class="n">DirichletBC</span><span class="p">(</span><span class="n">V</span><span class="p">,</span> <span class="n">u_D</span><span class="p">,</span> <span class="n">boundary</span><span class="p">)</span>
</pre></div>
</div>
<p>where <code class="docutils literal"><span class="pre">u_D</span></code> is an expression defining the solution values on the
boundary, and <code class="docutils literal"><span class="pre">boundary</span></code> is a function (or object) defining
which points belong to the boundary.</p>
<p>Boundary conditions of the type <span class="math">\(u=u_{_\mathrm{D}}\)</span> are known as <em>Dirichlet
conditions</em>. For the present finite element method for the Poisson
problem, they are also called <em>essential boundary conditions</em>, as they
need to be imposed explicitly as part of the trial space (in contrast
to being defined implicitly as part of the variational formulation).
Naturally, the FEniCS class used to define Dirichlet boundary
conditions is named <code class="docutils literal"><span class="pre">DirichletBC</span></code>.</p>
<p id="index-28">The variable <code class="docutils literal"><span class="pre">u_D</span></code> refers to an <code class="docutils literal"><span class="pre">Expression</span></code> object, which is used to
represent a mathematical function. The typical construction is</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">u_D</span> <span class="o">=</span> <span class="n">Expression</span><span class="p">(</span><span class="n">formula</span><span class="p">,</span> <span class="n">degree</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
</pre></div>
</div>
<p>where <code class="docutils literal"><span class="pre">formula</span></code> is a string containing a mathematical expression.
The formula must be written with C++ syntax and is
automatically turned into an efficient, compiled C++ function.</p>
<div class="admonition-expressions-and-accuracy admonition">
<p class="first admonition-title">Expressions and accuracy</p>
<p class="last">When defining an <code class="docutils literal"><span class="pre">Expression</span></code>, the second argument <code class="docutils literal"><span class="pre">degree</span></code> is a
parameter that specifies how the expression should be treated in
computations. On each local element, FEniCS will interpolate the
expression into a finite element space
of the specified degree. To obtain optimal
(order of) accuracy in computations, it is usually a good choice to
use the same degree as for the space <span class="math">\(V\)</span> that is used for the trial
and test functions. However, if an <code class="docutils literal"><span class="pre">Expression</span></code> is used to represent
an exact solution which is used to evaluate the accuracy of a computed
solution, a higher degree must be used for the expression (one or two
degrees higher).</p>
</div>
<p>The expression may depend on the variables <code class="docutils literal"><span class="pre">x[0]</span></code> and <code class="docutils literal"><span class="pre">x[1]</span></code>
corresponding to the <span class="math">\(x\)</span> and <span class="math">\(y\)</span> coordinates. In 3D, the expression
may also depend on the variable <code class="docutils literal"><span class="pre">x[2]</span></code> corresponding to the <span class="math">\(z\)</span>
coordinate. With our choice of <span class="math">\(u_{_\mathrm{D}}(x,y)=1 + x^2 + 2y^2\)</span>, the formula
string can be written as <code class="docutils literal"><span class="pre">1</span> <span class="pre">+</span> <span class="pre">x[0]*x[0]</span> <span class="pre">+</span> <span class="pre">2*x[1]*x[1]</span></code>:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">u_D</span> <span class="o">=</span> <span class="n">Expression</span><span class="p">(</span><span class="s1">&#39;1 + x[0]*x[0] + 2*x[1]*x[1]&#39;</span><span class="p">,</span> <span class="n">degree</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
</pre></div>
</div>
<p>We set the degree to <span class="math">\(2\)</span> so that <code class="docutils literal"><span class="pre">u_D</span></code> may represent the exact
quadratic solution to our test problem.</p>
<span class="target" id="index-29"></span><div class="admonition-string-expressions-must-have-valid-c-syntax admonition" id="index-30">
<p class="first admonition-title">String expressions must have valid C++ syntax</p>
<p>The string argument to an <code class="docutils literal"><span class="pre">Expression</span></code> object must obey C++ syntax.
Most Python syntax for mathematical expressions is also valid C++ syntax,
but power expressions make an exception: <code class="docutils literal"><span class="pre">p**a</span></code> must be written as
<code class="docutils literal"><span class="pre">pow(p,</span> <span class="pre">a)</span></code> in C++ (this is also an alternative Python syntax).
The following mathematical functions can be used directly
in C++
expressions when defining <code class="docutils literal"><span class="pre">Expression</span></code> objects:
<code class="docutils literal"><span class="pre">cos</span></code>, <code class="docutils literal"><span class="pre">sin</span></code>, <code class="docutils literal"><span class="pre">tan</span></code>, <code class="docutils literal"><span class="pre">acos</span></code>, <code class="docutils literal"><span class="pre">asin</span></code>,
<code class="docutils literal"><span class="pre">atan</span></code>, <code class="docutils literal"><span class="pre">atan2</span></code>, <code class="docutils literal"><span class="pre">cosh</span></code>, <code class="docutils literal"><span class="pre">sinh</span></code>, <code class="docutils literal"><span class="pre">tanh</span></code>, <code class="docutils literal"><span class="pre">exp</span></code>,
<code class="docutils literal"><span class="pre">frexp</span></code>, <code class="docutils literal"><span class="pre">ldexp</span></code>, <code class="docutils literal"><span class="pre">log</span></code>, <code class="docutils literal"><span class="pre">log10</span></code>, <code class="docutils literal"><span class="pre">modf</span></code>,
<code class="docutils literal"><span class="pre">pow</span></code>, <code class="docutils literal"><span class="pre">sqrt</span></code>, <code class="docutils literal"><span class="pre">ceil</span></code>, <code class="docutils literal"><span class="pre">fabs</span></code>, <code class="docutils literal"><span class="pre">floor</span></code>, and <code class="docutils literal"><span class="pre">fmod</span></code>.
Moreover, the number <span class="math">\(\pi\)</span> is available as the symbol <code class="docutils literal"><span class="pre">pi</span></code>.
All the listed functions are taken from the <code class="docutils literal"><span class="pre">cmath</span></code> C++ header file, and
one may hence
consult the documentation of <code class="docutils literal"><span class="pre">cmath</span></code> for more information on the
various functions.</p>
<p>If/else tests are possible using the C syntax for inline branching. The
function</p>
<div class="math">
\[\begin{split}f(x,y) = \left\lbrace\begin{array}{ll} x^2, &amp; x, y\geq 0,\\
2, &amp; \hbox{otherwise},\end{array}\right.\end{split}\]</div>
<p>is implemented as</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">f</span> <span class="o">=</span> <span class="n">Expression</span><span class="p">(</span><span class="s1">&#39;x[0]&gt;=0 &amp;&amp; x[1]&gt;=0 ? pow(x[0], 2) : 2&#39;</span><span class="p">,</span> <span class="n">degree</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
</pre></div>
</div>
<p>Parameters in expression strings are allowed, but
must be initialized via keyword
arguments when creating the <code class="docutils literal"><span class="pre">Expression</span></code> object. For example, the
function <span class="math">\(f(x)=e^{-\kappa\pi^2t}\sin(\pi k x)\)</span> can be coded as</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">f</span> <span class="o">=</span> <span class="n">Expression</span><span class="p">(</span><span class="s1">&#39;exp(-kappa*pow(pi, 2)*t)*sin(pi*k*x[0])&#39;</span><span class="p">,</span> <span class="n">degree</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span>
               <span class="n">kappa</span><span class="o">=</span><span class="mf">1.0</span><span class="p">,</span> <span class="n">t</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">k</span><span class="o">=</span><span class="mi">4</span><span class="p">)</span>
</pre></div>
</div>
<p>At any time, parameters can be updated:</p>
<div class="last highlight-python"><div class="highlight"><pre><span></span><span class="n">f</span><span class="o">.</span><span class="n">t</span> <span class="o">+=</span> <span class="n">dt</span>
<span class="n">f</span><span class="o">.</span><span class="n">k</span> <span class="o">=</span> <span class="mi">10</span>
</pre></div>
</div>
</div>
<p id="index-31">The function <code class="docutils literal"><span class="pre">boundary</span></code> specifies which points that belong to the
part of the boundary where the boundary condition should be applied:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="k">def</span> <span class="nf">boundary</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">on_boundary</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">on_boundary</span>
</pre></div>
</div>
<p>A function like <code class="docutils literal"><span class="pre">boundary</span></code> for marking the boundary must return a
boolean value: <code class="docutils literal"><span class="pre">True</span></code> if the given point <code class="docutils literal"><span class="pre">x</span></code> lies on the Dirichlet
boundary and <code class="docutils literal"><span class="pre">False</span></code> otherwise.  The argument <code class="docutils literal"><span class="pre">on_boundary</span></code> is <code class="docutils literal"><span class="pre">True</span></code>
if <code class="docutils literal"><span class="pre">x</span></code> is on the physical boundary of the mesh, so in the present
case, where we are supposed to return <code class="docutils literal"><span class="pre">True</span></code> for all points on the
boundary, we can just return the supplied value of <code class="docutils literal"><span class="pre">on_boundary</span></code>. The
<code class="docutils literal"><span class="pre">boundary</span></code> function will be called for every discrete point in the
mesh, which means that we may define boundaries where <span class="math">\(u\)</span> is also
known inside the domain, if desired.</p>
<p>One way to think about the specification of boundaries in FEniCS is
that FEniCS will ask you (or rather the function <code class="docutils literal"><span class="pre">boundary</span></code> which
you have implemented) whether or not a specific point <code class="docutils literal"><span class="pre">x</span></code> is part of
the boundary. FEniCS already knows whether the point belongs to the
<em>actual</em> boundary (the mathematical boundary of the domain) and kindly
shares this information with you in the variable <code class="docutils literal"><span class="pre">on_boundary</span></code>. You
may choose to use this information (as we do here), or ignore it
completely.</p>
<p>The argument <code class="docutils literal"><span class="pre">on_boundary</span></code> may also be omitted, but in that case we need
to test on the value of the coordinates in <code class="docutils literal"><span class="pre">x</span></code>:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="k">def</span> <span class="nf">boundary</span><span class="p">(</span><span class="n">x</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="mi">0</span> <span class="ow">or</span> <span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="mi">0</span> <span class="ow">or</span> <span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">==</span> <span class="mi">1</span> <span class="ow">or</span> <span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="mi">1</span>
</pre></div>
</div>
<p>Comparing floating-point values using an exact match test with
<code class="docutils literal"><span class="pre">==</span></code> is not good programming practice, because small round-off errors
in the computations of the <code class="docutils literal"><span class="pre">x</span></code> values could make a test <code class="docutils literal"><span class="pre">x[0]</span> <span class="pre">==</span> <span class="pre">1</span></code>
become false even though <code class="docutils literal"><span class="pre">x</span></code> lies on the boundary.  A better test is
to check for equality with a tolerance, either explicitly</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">tol</span> <span class="o">=</span> <span class="mf">1E-14</span>
<span class="k">def</span> <span class="nf">boundary</span><span class="p">(</span><span class="n">x</span><span class="p">):</span>
    <span class="k">return</span> <span class="nb">abs</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span> <span class="o">&lt;</span> <span class="n">tol</span> <span class="ow">or</span> <span class="nb">abs</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span> <span class="o">&lt;</span> <span class="n">tol</span> \
        <span class="ow">or</span> <span class="nb">abs</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">-</span> <span class="mi">1</span><span class="p">)</span> <span class="o">&lt;</span> <span class="n">tol</span> <span class="ow">or</span> <span class="nb">abs</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="mi">1</span><span class="p">)</span> <span class="o">&lt;</span> <span class="n">tol</span>
</pre></div>
</div>
<p>or using the <code class="docutils literal"><span class="pre">near</span></code> command in FEniCS:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="k">def</span> <span class="nf">boundary</span><span class="p">(</span><span class="n">x</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">near</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="mi">0</span><span class="p">,</span> <span class="n">tol</span><span class="p">)</span> <span class="ow">or</span> <span class="n">near</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="mi">0</span><span class="p">,</span> <span class="n">tol</span><span class="p">)</span> \
        <span class="ow">or</span> <span class="n">near</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="mi">1</span><span class="p">,</span> <span class="n">tol</span><span class="p">)</span> <span class="ow">or</span> <span class="n">near</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span> <span class="mi">1</span><span class="p">,</span> <span class="n">tol</span><span class="p">)</span>
</pre></div>
</div>
<span class="target" id="index-32"></span><div class="admonition-never-use-for-comparing-real-numbers admonition" id="index-33">
<p class="first admonition-title">Never use <code class="docutils literal"><span class="pre">==</span></code> for comparing real numbers</p>
<p>A comparison like <code class="docutils literal"><span class="pre">x[0]</span> <span class="pre">==</span> <span class="pre">1</span></code> should never be used if <code class="docutils literal"><span class="pre">x[0]</span></code> is a real
number, because rounding errors in <code class="docutils literal"><span class="pre">x[0]</span></code> may make the test fail even
when it is mathematically correct. Consider the following calculations
in Python:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="mf">0.1</span> <span class="o">+</span> <span class="mf">0.2</span> <span class="o">==</span> <span class="mf">0.3</span>
<span class="go">False</span>
<span class="gp">&gt;&gt;&gt; </span><span class="mf">0.1</span> <span class="o">+</span> <span class="mf">0.2</span>
<span class="go">0.30000000000000004</span>
</pre></div>
</div>
<p>Comparison of real numbers needs to be made with tolerances! The
values of the tolerances depend on the size of the numbers involved in
arithmetic operations:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="nb">abs</span><span class="p">(</span><span class="mf">0.1</span> <span class="o">+</span> <span class="mf">0.2</span> <span class="o">-</span> <span class="mf">0.3</span><span class="p">)</span>
<span class="go">5.551115123125783e-17</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">abs</span><span class="p">(</span><span class="mf">1.1</span> <span class="o">+</span> <span class="mf">1.2</span> <span class="o">-</span> <span class="mf">2.3</span><span class="p">)</span>
<span class="go">0.0</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">abs</span><span class="p">(</span><span class="mf">10.1</span> <span class="o">+</span> <span class="mf">10.2</span> <span class="o">-</span> <span class="mf">20.3</span><span class="p">)</span>
<span class="go">3.552713678800501e-15</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">abs</span><span class="p">(</span><span class="mf">100.1</span> <span class="o">+</span> <span class="mf">100.2</span> <span class="o">-</span> <span class="mf">200.3</span><span class="p">)</span>
<span class="go">0.0</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">abs</span><span class="p">(</span><span class="mf">1000.1</span> <span class="o">+</span> <span class="mf">1000.2</span> <span class="o">-</span> <span class="mf">2000.3</span><span class="p">)</span>
<span class="go">2.2737367544323206e-13</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">abs</span><span class="p">(</span><span class="mf">10000.1</span> <span class="o">+</span> <span class="mf">10000.2</span> <span class="o">-</span> <span class="mf">20000.3</span><span class="p">)</span>
<span class="go">3.637978807091713e-12</span>
</pre></div>
</div>
<p class="last">For numbers of unit size, tolerances as low as <span class="math">\(3\cdot 10^{-16}\)</span> can be used
(in fact, this tolerance is known as the constant <code class="docutils literal"><span class="pre">DOLFIN_EPS</span></code> in FEniCS).
Otherwise, an appropriately scaled tolerance must be used.</p>
</div>
</div>
<div class="section" id="defining-the-source-term">
<span id="index-34"></span><h3>Defining the source term<a class="headerlink" href="#defining-the-source-term" title="Permalink to this headline">¶</a></h3>
<p>Before defining the bilinear and linear forms <span class="math">\(a(u,v)\)</span> and <span class="math">\(L(v)\)</span> we
have to specify the source term <span class="math">\(f\)</span>:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">f</span> <span class="o">=</span> <span class="n">Expression</span><span class="p">(</span><span class="s1">&#39;-6&#39;</span><span class="p">,</span> <span class="n">degree</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
</pre></div>
</div>
<p>When <span class="math">\(f\)</span> is constant over the domain, <code class="docutils literal"><span class="pre">f</span></code> can be
more efficiently represented as a <code class="docutils literal"><span class="pre">Constant</span></code>:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">f</span> <span class="o">=</span> <span class="n">Constant</span><span class="p">(</span><span class="o">-</span><span class="mi">6</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="section" id="defining-the-variational-problem-1">
<h3>Defining the variational problem<a class="headerlink" href="#defining-the-variational-problem-1" title="Permalink to this headline">¶</a></h3>
<p>We now have all the ingredients we need to define the
variational problem:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">a</span> <span class="o">=</span> <span class="n">dot</span><span class="p">(</span><span class="n">grad</span><span class="p">(</span><span class="n">u</span><span class="p">),</span> <span class="n">grad</span><span class="p">(</span><span class="n">v</span><span class="p">))</span><span class="o">*</span><span class="n">dx</span>
<span class="n">L</span> <span class="o">=</span> <span class="n">f</span><span class="o">*</span><span class="n">v</span><span class="o">*</span><span class="n">dx</span>
</pre></div>
</div>
<p>In essence, these two lines specify the PDE to be solved.  Note the
very close correspondence between the Python syntax and the
mathematical formulas <span class="math">\(\nabla u\cdot\nabla v {\, \mathrm{d}x}\)</span> and <span class="math">\(fv {\, \mathrm{d}x}\)</span>.  This
is a key strength of FEniCS: the formulas in the variational
formulation translate directly to very similar Python code, a feature
that makes it easy to specify and solve complicated PDE problems. The
language used to express weak forms is called UFL (Unified Form
Language) <a class="reference internal" href="._ftut1006.html#ref05" id="id3">[Ref05]</a> <a class="reference internal" href="._ftut1006.html#ref01" id="id4">[Ref01]</a> and is an integral part of FEniCS.</p>
<div class="admonition-expressing-inner-products admonition">
<p class="first admonition-title">Expressing inner products</p>
<p class="last">The inner product <span class="math">\(\int_{\Omega} \nabla u \cdot \nabla v {\, \mathrm{d}x}\)</span>
can be expressed in various ways in FEniCS. Above, we have used
the notation <code class="docutils literal"><span class="pre">dot(grad(u),</span> <span class="pre">grad(v))*dx</span></code>. The dot product in
FEniCS/UFL computes the sum (contraction) over the last index
of the first factor and the first index of the second factor.
In this case, both factors are tensors of rank one (vectors) and
so the sum is just over the one single index of both <span class="math">\(\nabla u\)</span>
and <span class="math">\(\nabla v\)</span>. To compute an inner product of matrices (with
two indices), one must instead of <code class="docutils literal"><span class="pre">dot</span></code> use the function <code class="docutils literal"><span class="pre">inner</span></code>.
For vectors, <code class="docutils literal"><span class="pre">dot</span></code> and <code class="docutils literal"><span class="pre">inner</span></code> are equivalent.</p>
</div>
</div>
<div class="section" id="forming-and-solving-the-linear-system">
<h3>Forming and solving the linear system<a class="headerlink" href="#forming-and-solving-the-linear-system" title="Permalink to this headline">¶</a></h3>
<p>Having defined the finite element variational problem and boundary
condition, we can now ask FEniCS to compute the solution:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">u</span> <span class="o">=</span> <span class="n">Function</span><span class="p">(</span><span class="n">V</span><span class="p">)</span>
<span class="n">solve</span><span class="p">(</span><span class="n">a</span> <span class="o">==</span> <span class="n">L</span><span class="p">,</span> <span class="n">u</span><span class="p">,</span> <span class="n">bc</span><span class="p">)</span>
</pre></div>
</div>
<p>Note that we first defined the variable <code class="docutils literal"><span class="pre">u</span></code> as a <code class="docutils literal"><span class="pre">TrialFunction</span></code> and
used it to represent the unknown in the form <code class="docutils literal"><span class="pre">a</span></code>. Thereafter, we
redefined <code class="docutils literal"><span class="pre">u</span></code> to be a <code class="docutils literal"><span class="pre">Function</span></code> object representing the solution;
i.e., the computed finite element function <span class="math">\(u\)</span>. This redefinition of
the variable <code class="docutils literal"><span class="pre">u</span></code> is possible in Python and is often used in FEniCS
applications for linear problems. The two types of objects that <code class="docutils literal"><span class="pre">u</span></code>
refers to are equal from a mathematical point of view, and hence it is
natural to use the same variable name for both objects.</p>
</div>
<div class="section" id="plotting-the-solution-using-the-plot-command">
<span id="index-35"></span><h3>Plotting the solution using the <code class="docutils literal"><span class="pre">plot</span></code> command<a class="headerlink" href="#plotting-the-solution-using-the-plot-command" title="Permalink to this headline">¶</a></h3>
<span class="target" id="index-36"></span><p id="index-37">Once the solution has been computed, it can be visualized by
the <code class="docutils literal"><span class="pre">plot</span></code> command:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">plot</span><span class="p">(</span><span class="n">u</span><span class="p">)</span>
<span class="n">plot</span><span class="p">(</span><span class="n">mesh</span><span class="p">)</span>
<span class="n">interactive</span><span class="p">()</span>
</pre></div>
</div>
<p>Note the call to the function <code class="docutils literal"><span class="pre">interactive</span></code> after the <code class="docutils literal"><span class="pre">plot</span></code> commands.
This call makes it possible to interact with the plots (rotating and
zooming). The call to <code class="docutils literal"><span class="pre">interactive</span></code> is usually placed at the end of a
program that creates plots.  Figure <a class="reference internal" href="#fig-poisson-plot"><span>Plot of the mesh and the solution for the Poisson problem created using the built-in FEniCS visualization tool (``plot`` command)</span></a> displays the
two plots.</p>
<div class="figure" id="id6">
<span id="fig-poisson-plot"></span><a class="reference internal image-reference" href="_images/poisson_plot.png"><img alt="_images/poisson_plot.png" src="_images/poisson_plot.png" style="width: 800px;" /></a>
<p class="caption"><span class="caption-text"><em>Plot of the mesh and the solution for the Poisson problem created using the built-in FEniCS visualization tool (``plot`` command)</em></span></p>
</div>
<p>The <code class="docutils literal"><span class="pre">plot</span></code> command is useful for debugging and initial scientific
investigations. More advanced visualizations are better created by
exporting the solution to a file and using an advanced visualization
tool like ParaView, as explained in the next section.</p>
<p>By clicking the left mouse button in the plot window, you may rotate
the solution, while the right mouse button is used for zooming. Point
the mouse to the <code class="docutils literal"><span class="pre">Help</span></code> text in the lower left corner to display a
list of all available shortcut commands. The help menu may
alternatively be activated by typing <strong>h</strong> in the plot window. The
<code class="docutils literal"><span class="pre">plot</span></code> command also accepts a number of additional arguments, such as
for example setting the title of the plot window:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">plot</span><span class="p">(</span><span class="n">u</span><span class="p">,</span> <span class="n">title</span><span class="o">=</span><span class="s1">&#39;Finite element solution&#39;</span><span class="p">)</span>
<span class="n">plot</span><span class="p">(</span><span class="n">mesh</span><span class="p">,</span> <span class="n">title</span><span class="o">=</span><span class="s1">&#39;Finite element mesh&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>For detailed documentation, either run the command <code class="docutils literal"><span class="pre">help(plot)</span></code> in
Python or <code class="docutils literal"><span class="pre">pydoc</span> <span class="pre">fenics.plot</span></code> from a terminal window.</p>
<div class="admonition-built-in-plotting-on-mac-os-x-and-in-docker admonition">
<p class="first admonition-title">Built-in plotting on Mac OS X and in Docker</p>
<p class="last">The built-in plotting in FEniCS may not work as expected when either
running on Mac OS X or when running inside a FEniCS Docker container.
FEniCS supports plotting using the <code class="docutils literal"><span class="pre">plot</span></code> command on Mac OS
X. However, the keyboard shortcuts may fail
to work. When running inside a Docker container, plotting is not
supported since Docker does not interact with your windowing system.
For Docker users who need plotting, it is recommended to either work
within a Jupyter/FEniCS notebook (command <code class="docutils literal"><span class="pre">fenicsproject</span> <span class="pre">notebook</span></code>)
or rely on ParaView or other external tools for visualization.</p>
</div>
</div>
<div class="section" id="plotting-the-solution-using-paraview">
<h3>Plotting the solution using ParaView<a class="headerlink" href="#plotting-the-solution-using-paraview" title="Permalink to this headline">¶</a></h3>
<span class="target" id="index-38"></span><span class="target" id="index-39"></span><p id="index-40">The simple <code class="docutils literal"><span class="pre">plot</span></code> command is useful for quick visualizations, but for
more advanced visualizations an external tool must be used. In this
section we demonstrate how to visualize solutions in ParaView.
<a class="reference external" href="http://www.paraview.org">ParaView</a> is a powerful
tool for visualizing scalar and vector fields, including those
computed by FEniCS.</p>
<p>The first step is to export the solution in VTK format:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">vtkfile</span> <span class="o">=</span> <span class="n">File</span><span class="p">(</span><span class="s1">&#39;poisson/solution.pvd&#39;</span><span class="p">)</span>
<span class="n">vtkfile</span> <span class="o">&lt;&lt;</span> <span class="n">u</span>
</pre></div>
</div>
<p>The following steps demonstrate how to create a plot of the solution
of our Poisson problem in ParaView. The resulting plot is shown in
Figure <a class="reference internal" href="#fig-poisson-paraview"><span>Plot of the mesh and the solution for the Poisson problem created using ParaView</span></a>.</p>
<ol class="arabic simple">
<li>Start the ParaView application.</li>
<li>Click <strong>File - Open...</strong> in the top menu and navigate to the directory containing the exported solution. This should be inside a subdirectory named <code class="docutils literal"><span class="pre">poisson</span></code> below the directory where the FEniCS Python program was started. Select the file named <code class="docutils literal"><span class="pre">solution.pvd</span></code> and then click <strong>OK</strong>.</li>
<li>Click <strong>Apply</strong> in the Properties pane on the left. This will bring up a plot of the solution.</li>
<li>To make a 3D plot of the solution, we will make use of one of ParaView&#8217;s many <em>filters</em>. Click <strong>Filters - Alphabetical - Warp By Scalar</strong> in the top menu and then <strong>Apply</strong> in the Properties pane on the left. This create an elevated surface with the height determined by the solution value.</li>
<li>To show the original plot below the elevated surface, click the little eye icon to the left of <code class="docutils literal"><span class="pre">solution.pvd</span></code> in the Pipeline Browser pane on the left. Also click the little 2D button at the top of the plot window to change the visualization to 3D. This lets you interact with the plot by rotating (left mouse button) and zooming (Ctrl + left mouse button).</li>
<li>To show the finite element mesh, click on <code class="docutils literal"><span class="pre">solution.pvd</span></code> in the Pipeline Browser, navigate to <strong>Representation</strong> in the Properties pane, and select <strong>Surface With Edges</strong>. This should make the finite element mesh visible.</li>
<li>To change the aspect ratio of the plot, click on <strong>WarpByScalar1</strong> in the Pipeline Browser and navigate to <strong>Scale Factor</strong> in the Properties pane. Change the value to 0.2 and click <strong>Apply</strong>. This will change the scale of the warped plot. We also unclick <strong>Orientation Axis Visibility</strong> at the bottom of the Properties pane to remove the little 3D axes in the lower left corner of the plot window. You should now see something that resembles the plot in Figure <a class="reference internal" href="#fig-poisson-paraview"><span>Plot of the mesh and the solution for the Poisson problem created using ParaView</span></a>.</li>
<li>Finally, to export the visualization to a file, click <strong>File - Save Screenshot...</strong> and select a suitable file name such as <code class="docutils literal"><span class="pre">poisson.png</span></code>.</li>
</ol>
<p>For more information, we refer to The ParaView Guide <a class="reference internal" href="._ftut1006.html#ref27" id="id5">[Ref27]</a>
(free PDF available), the <a class="reference external" href="http://www.paraview.org/Wiki/The_ParaView_Tutorial">ParaView tutorial</a>, and the instruction
video <a class="reference external" href="https://vimeo.com/34037236">Introduction to ParaView</a>.</p>
<div class="figure" id="id7">
<span id="fig-poisson-paraview"></span><a class="reference internal image-reference" href="_images/poisson_paraview.png"><img alt="_images/poisson_paraview.png" src="_images/poisson_paraview.png" style="width: 800px;" /></a>
<p class="caption"><span class="caption-text"><em>Plot of the mesh and the solution for the Poisson problem created using ParaView</em></span></p>
</div>
</div>
<div class="section" id="computing-the-error">
<h3>Computing the error<a class="headerlink" href="#computing-the-error" title="Permalink to this headline">¶</a></h3>
<p id="index-41">Finally, we compute the error to check the accuracy of the solution.
We do this by comparing the finite element solution <code class="docutils literal"><span class="pre">u</span></code> with the exact
solution, which in this example happens to be the same as the
expression <code class="docutils literal"><span class="pre">u_D</span></code> used to set the boundary conditions. We compute the
error in two different ways. First, we compute the <span class="math">\(L^2\)</span> norm of the
error, defined by</p>
<div class="math">
\[E = \sqrt{\int_\Omega (u_{_\mathrm{D}} - u)^2{\, \mathrm{d}x}}{\thinspace .}\]</div>
<p>Since the exact solution is quadratic and the finite element solution
is piecewise linear, this error will be nonzero. To compute this error
in FEniCS, we simply write</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">error_L2</span> <span class="o">=</span> <span class="n">errornorm</span><span class="p">(</span><span class="n">u_D</span><span class="p">,</span> <span class="n">u</span><span class="p">,</span> <span class="s1">&#39;L2&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>The <code class="docutils literal"><span class="pre">errornorm</span></code> function can also compute other error norms such
as the <span class="math">\(H^1\)</span> norm. Type <code class="docutils literal"><span class="pre">pydoc</span> <span class="pre">fenics.errornorm</span></code> in a terminal window
for details.</p>
<p>We also compute the maximum value of the error at all the vertices of
the finite element mesh. As mentioned above, we expect this error to
be zero to within machine precision for this particular example. To
compute the error at the vertices, we first ask FEniCS to compute the
value of both <code class="docutils literal"><span class="pre">u_D</span></code> and <code class="docutils literal"><span class="pre">u</span></code> at all vertices, and then subtract the
results:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">vertex_values_u_D</span> <span class="o">=</span> <span class="n">u_D</span><span class="o">.</span><span class="n">compute_vertex_values</span><span class="p">(</span><span class="n">mesh</span><span class="p">)</span>
<span class="n">vertex_values_u</span> <span class="o">=</span> <span class="n">u</span><span class="o">.</span><span class="n">compute_vertex_values</span><span class="p">(</span><span class="n">mesh</span><span class="p">)</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="n">error_max</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">vertex_values_u_D</span> <span class="o">-</span> <span class="n">vertex_values_u</span><span class="p">))</span>
</pre></div>
</div>
<p>We have here used the maximum and absolute value functions from <code class="docutils literal"><span class="pre">numpy</span></code>,
because these are much more efficient for large arrays (a factor of 30)
than Python&#8217;s built-in <code class="docutils literal"><span class="pre">max</span></code> and <code class="docutils literal"><span class="pre">abs</span></code> functions.</p>
<div class="admonition-how-to-check-that-the-error-vanishes admonition">
<p class="first admonition-title">How to check that the error vanishes</p>
<p class="last">With inexact (floating point) arithmetic, the maximum
error at the vertices is not zero, but should be a small number. The
machine precision is about <span class="math">\(10^{-16}\)</span>, but in finite element
calculations, rounding errors of this size may accumulate, to produce
an error larger than <span class="math">\(10^{-16}\)</span>. Experiments show that increasing the
number of elements and increasing the degree of the finite element
polynomials increases the error. For a mesh with <span class="math">\(2\times(20\times
20)\)</span> cubic Lagrange elements (degree 3) the error is about <span class="math">\(2\cdot
10^{-12}\)</span>, while for 128 linear elements the error is about <span class="math">\(2\cdot
10^{-15}\)</span>.</p>
</div>
</div>
<div class="section" id="examining-degrees-of-freedom-and-vertex-values">
<span id="ch-poisson0-impl-dofmap"></span><h3>Examining degrees of freedom and vertex values<a class="headerlink" href="#examining-degrees-of-freedom-and-vertex-values" title="Permalink to this headline">¶</a></h3>
<span class="target" id="index-42"></span><span class="target" id="index-43"></span><span class="target" id="index-44"></span><p id="index-45">A finite element function like <span class="math">\(u\)</span> is expressed as a linear combination
of basis functions <span class="math">\(\phi_j\)</span>, spanning the space <span class="math">\(V\)</span>:</p>
<div class="math" id="eq-ch-poisson0-ufem">
\[\tag{13}
u = \sum_{j=1}^N U_j \phi_j {\thinspace .}\]</div>
<p>By writing <code class="docutils literal"><span class="pre">solve(a</span> <span class="pre">==</span> <span class="pre">L,</span> <span class="pre">u,</span> <span class="pre">bc)</span></code> in the program, a linear system will
be formed from <span class="math">\(a\)</span> and <span class="math">\(L\)</span>, and this system is solved for the
values <span class="math">\(U_1,\ldots,U_N\)</span>. The values <span class="math">\(U_1,\ldots,U_N\)</span> are known as the
<em>degrees of freedom</em> (&#8220;dofs&#8221;) or <em>nodal values</em> of <span class="math">\(u\)</span>. For Lagrange
elements (and many other element types) <span class="math">\(U_j\)</span> is simply the value of
<span class="math">\(u\)</span> at the node with global number <span class="math">\(j\)</span>. The locations of the nodes and
cell vertices coincide for linear Lagrange elements, while for
higher-order elements there are additional nodes associated with the
facets, edges and sometimes also the interior of cells.</p>
<p>Having <code class="docutils literal"><span class="pre">u</span></code> represented as a <code class="docutils literal"><span class="pre">Function</span></code> object, we can either evaluate
<code class="docutils literal"><span class="pre">u(x)</span></code> at any point <code class="docutils literal"><span class="pre">x</span></code> in the mesh (expensive operation!), or we can
grab all the degrees of freedom in the vector <span class="math">\(U\)</span> directly by</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">nodal_values_u</span> <span class="o">=</span> <span class="n">u</span><span class="o">.</span><span class="n">vector</span><span class="p">()</span>
</pre></div>
</div>
<p>The result is a <code class="docutils literal"><span class="pre">Vector</span></code> object, which is basically an encapsulation
of the vector object used in the linear algebra package that is used
to solve the linear system arising from the variational problem.
Since we program in Python it is convenient to convert the <code class="docutils literal"><span class="pre">Vector</span></code>
object to a standard <code class="docutils literal"><span class="pre">numpy</span></code> array for further processing:</p>
<span class="target" id="index-46"></span><span class="target" id="index-47"></span><span class="target" id="index-48"></span><div class="highlight-python" id="index-49"><div class="highlight"><pre><span></span><span class="n">array_u</span> <span class="o">=</span> <span class="n">nodal_values_u</span><span class="o">.</span><span class="n">array</span><span class="p">()</span>
</pre></div>
</div>
<p>With <code class="docutils literal"><span class="pre">numpy</span></code> arrays we can write MATLAB-like code to analyze the
data. Indexing is done with square brackets: <code class="docutils literal"><span class="pre">array_u[j]</span></code>, where the
index <code class="docutils literal"><span class="pre">j</span></code> always starts at <code class="docutils literal"><span class="pre">0</span></code>. If the solution is computed with
piecewise linear Lagrange elements (<span class="math">\(\mathsf{P}_1\)</span>), then the size of
the array <code class="docutils literal"><span class="pre">array_u</span></code> is equal to the number of vertices, and each
<code class="docutils literal"><span class="pre">array_u[j]</span></code> is the value at some vertex in the mesh. However, the degrees
of freedom are not necessarily numbered in the same way as the
vertices of the
mesh. (This is discussed in some detail in the section <a class="reference internal" href="._ftut1006.html#ch-poisson0-verify1"><span>Examining the degrees of freedom</span></a>).
If we therefore want to know the values at the vertices, we need to
call the function <code class="docutils literal"><span class="pre">u.compute_vertex_values</span></code>. This function returns
the values at all the vertices of the mesh as a <code class="docutils literal"><span class="pre">numpy</span></code> array with the same
numbering as for the vertices of the mesh, for example:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">vertex_values_u</span> <span class="o">=</span> <span class="n">u</span><span class="o">.</span><span class="n">compute_vertex_values</span><span class="p">()</span>
</pre></div>
</div>
<p>Note that for <span class="math">\(\mathsf{P}_1\)</span> elements, the arrays <code class="docutils literal"><span class="pre">array_u</span></code> and <code class="docutils literal"><span class="pre">vertex_values_u</span></code> have the same lengths and contain the same values, albeit in different order.</p>
</div>
</div>
<div class="section" id="deflection-of-a-membrane">
<span id="ch-poisson0-membrane"></span><h2>Deflection of a membrane<a class="headerlink" href="#deflection-of-a-membrane" title="Permalink to this headline">¶</a></h2>
<p>Our first FEniCS program for the Poisson equation targeted a
simple test problem where we could easily verify the
implementation. We now turn our attention to a physically more
relevant problem with solutions of somewhat more exciting shape.</p>
<p>We want to compute the deflection <span class="math">\(D(x,y)\)</span> of a two-dimensional,
circular membrane of radius <span class="math">\(R\)</span>, subject to a load <span class="math">\(p\)</span> over the
membrane. The appropriate PDE model is</p>
<div class="math" id="eq-auto3">
\[\tag{14}
-T\nabla^2 D = p\quad\hbox{in }\Omega = \{ (x,y)\,\vert\, x^2+y^2\leq R\}{\thinspace .}\]</div>
<p>Here, <span class="math">\(T\)</span> is the tension in the membrane (constant), and <span class="math">\(p\)</span> is the external
pressure load.
The boundary of the membrane has no
deflection, implying <span class="math">\(D=0\)</span> as a boundary condition.
A localized load can be modeled as a Gaussian function:</p>
<div class="math" id="eq-auto4">
\[\tag{15}
p(x,y) = {A\over 2\pi\sigma}\exp{\left(
    - {1\over2}\left( {x-x_0\over\sigma}\right)^2
    - {1\over2}\left( {y-y_0\over\sigma}\right)^2
    \right)}\, .\]</div>
<p>The parameter <span class="math">\(A\)</span> is the amplitude of the pressure, <span class="math">\((x_0,y_0)\)</span> the
localization of the maximum point of the load, and <span class="math">\(\sigma\)</span> the
&#8220;width&#8221; of <span class="math">\(p\)</span>. We will take the center <span class="math">\((x_0,y_0)\)</span> of the pressure
to be <span class="math">\((0, R_0)\)</span> for some <span class="math">\(0 &lt; R_0 &lt; R\)</span>.</p>
<div class="section" id="scaling-the-equation">
<h3>Scaling the equation<a class="headerlink" href="#scaling-the-equation" title="Permalink to this headline">¶</a></h3>
<p>There are many physical parameters in this problem, and we can benefit
from grouping them by means of scaling. Let us introduce dimensionless
coordinates <span class="math">\(\bar x = x/R\)</span>, <span class="math">\(\bar y = y/R\)</span>, and a dimensionless
deflection <span class="math">\(w=D/D_c\)</span>, where <span class="math">\(D_c\)</span> is a characteristic size of the
deflection. Introducing <span class="math">\(\bar R_0=R_0/R\)</span>, we obtain</p>
<div class="math">
\[\begin{split}-\frac{\partial^2 w}{\partial\bar x^2}
-\frac{\partial^2 w}{\partial\bar y^2}= \alpha
\exp{\left(
- \beta^2(\bar x^2
+ (\bar y-\bar R_0)^2)\right)}\hbox{ for } \bar x^2 + \bar y^2 &lt; 1,\end{split}\]</div>
<p>where</p>
<div class="math">
\[\alpha = \frac{R^2A}{2\pi T D_c\sigma},\quad\beta = \frac{R}{\sqrt{2}\sigma}{\thinspace .}\]</div>
<p>With an appropriate scaling, <span class="math">\(w\)</span> and its derivatives are of size
unity, so the left-hand side of the scaled PDE is about unity in size,
while the right-hand side has <span class="math">\(\alpha\)</span> as its characteristic size.
This suggest choosing <span class="math">\(\alpha\)</span> to be unity, or around unity. We shall
in this particular case choose <span class="math">\(\alpha=4\)</span>. (One can also find the
analytical solution in scaled coordinates and show that the maximum
deflection <span class="math">\(D(0,0)\)</span> is <span class="math">\(D_c\)</span> if we choose <span class="math">\(\alpha=4\)</span> to determine
<span class="math">\(D_c\)</span>.) With <span class="math">\(D_c=AR^2/(8\pi\sigma T)\)</span> and dropping the bars we obtain
the scaled problem</p>
<div class="math" id="eq-ch-poisson0-membrane-scaled-eq">
\[\tag{16}
-\nabla^2w = 4\exp{\left(
    - \beta^2(x^2
    + (y-R_0)^2)\right)},\]</div>
<p>to be solved over the unit disc with <span class="math">\(w=0\)</span> on the boundary. Now
there are only two parameters to vary: the dimensionless extent of the
pressure, <span class="math">\(\beta\)</span>, and the localization of the pressure peak, <span class="math">\(R_0\in
[0,1]\)</span>.  As <span class="math">\(\beta\rightarrow 0\)</span>, the solution will approach the
special case <span class="math">\(w=1-x^2-y^2\)</span>.</p>
<p>Given a computed scaled solution <span class="math">\(w\)</span>, the physical deflection can be computed by</p>
<div class="math">
\[D = \frac{AR^2}{8\pi\sigma T}w{\thinspace .}\]</div>
<p>Just a few modifications are necessary to our previous program to solve
this new problem.</p>
</div>
<div class="section" id="defining-the-mesh">
<h3>Defining the mesh<a class="headerlink" href="#defining-the-mesh" title="Permalink to this headline">¶</a></h3>
<p>A mesh over the unit disk can be created by the <code class="docutils literal"><span class="pre">mshr</span></code> tool in
FEniCS:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">mshr</span> <span class="kn">import</span> <span class="o">*</span>
<span class="n">domain</span> <span class="o">=</span> <span class="n">Circle</span><span class="p">(</span><span class="n">Point</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">),</span> <span class="mi">1</span><span class="p">)</span>
<span class="n">mesh</span> <span class="o">=</span> <span class="n">generate_mesh</span><span class="p">(</span><span class="n">domain</span><span class="p">,</span> <span class="mi">64</span><span class="p">)</span>
</pre></div>
</div>
<p>The <code class="docutils literal"><span class="pre">Circle</span></code> shape from <code class="docutils literal"><span class="pre">mshr</span></code> takes the center and radius of the
circle as arguments. The second argument to the <code class="docutils literal"><span class="pre">generate_mesh</span></code>
function specifies the desired mesh resolution. The cell size will be
(approximately) equal to the diameter of the domain divided by the
resolution.</p>
</div>
<div class="section" id="defining-the-load">
<h3>Defining the load<a class="headerlink" href="#defining-the-load" title="Permalink to this headline">¶</a></h3>
<p id="index-50">The right-hand side pressure function
is represented by an <code class="docutils literal"><span class="pre">Expression</span></code> object. There
are two physical parameters in the formula for <span class="math">\(f\)</span> that enter the
expression string and these parameters must have their values set
by keyword arguments:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">beta</span> <span class="o">=</span> <span class="mi">8</span>
<span class="n">R0</span> <span class="o">=</span> <span class="mf">0.6</span>
<span class="n">p</span> <span class="o">=</span> <span class="n">Expression</span><span class="p">(</span><span class="s1">&#39;4*exp(-pow(beta, 2)*(pow(x[0], 2) + pow(x[1] - R0, 2)))&#39;</span><span class="p">,</span>
               <span class="n">degree</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">beta</span><span class="o">=</span><span class="n">beta</span><span class="p">,</span> <span class="n">R0</span><span class="o">=</span><span class="n">R0</span><span class="p">)</span>
</pre></div>
</div>
<p>The coordinates in <code class="docutils literal"><span class="pre">Expression</span></code> objects are always an array
<code class="docutils literal"><span class="pre">x</span></code> with components <code class="docutils literal"><span class="pre">x[0]</span></code>, <code class="docutils literal"><span class="pre">x[1]</span></code>, and <code class="docutils literal"><span class="pre">x[2]</span></code>, corresponding to
<span class="math">\(x\)</span>, <span class="math">\(y\)</span>, and <span class="math">\(z\)</span>.
Otherwise we are free to introduce names of parameters as long as
these are given default values by keyword arguments. All the
parameters initialized by keyword arguments can at any time have their
values modified. For example, we may set</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">p</span><span class="o">.</span><span class="n">beta</span> <span class="o">=</span> <span class="mi">12</span>
<span class="n">p</span><span class="o">.</span><span class="n">R0</span> <span class="o">=</span> <span class="mf">0.3</span>
</pre></div>
</div>
</div>
<div class="section" id="defining-the-variational-problem-2">
<h3>Defining the variational problem<a class="headerlink" href="#defining-the-variational-problem-2" title="Permalink to this headline">¶</a></h3>
<p>The variational problem is the same as in
our first Poisson problem, but we may introduce <code class="docutils literal"><span class="pre">w</span></code> instead of <code class="docutils literal"><span class="pre">u</span></code> as
primary unknown and <code class="docutils literal"><span class="pre">p</span></code> instead of <code class="docutils literal"><span class="pre">f</span></code> as right-hand side function:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">w</span> <span class="o">=</span> <span class="n">TrialFunction</span><span class="p">(</span><span class="n">V</span><span class="p">)</span>
<span class="n">v</span> <span class="o">=</span> <span class="n">TestFunction</span><span class="p">(</span><span class="n">V</span><span class="p">)</span>
<span class="n">a</span> <span class="o">=</span> <span class="n">dot</span><span class="p">(</span><span class="n">grad</span><span class="p">(</span><span class="n">w</span><span class="p">),</span> <span class="n">grad</span><span class="p">(</span><span class="n">v</span><span class="p">))</span><span class="o">*</span><span class="n">dx</span>
<span class="n">L</span> <span class="o">=</span> <span class="n">p</span><span class="o">*</span><span class="n">v</span><span class="o">*</span><span class="n">dx</span>

<span class="n">w</span> <span class="o">=</span> <span class="n">Function</span><span class="p">(</span><span class="n">V</span><span class="p">)</span>
<span class="n">solve</span><span class="p">(</span><span class="n">a</span> <span class="o">==</span> <span class="n">L</span><span class="p">,</span> <span class="n">w</span><span class="p">,</span> <span class="n">bc</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="section" id="plotting-the-solution">
<h3>Plotting the solution<a class="headerlink" href="#plotting-the-solution" title="Permalink to this headline">¶</a></h3>
<p>It is of interest to visualize the pressure <span class="math">\(p\)</span> along with the
deflection <span class="math">\(w\)</span> so that we may examine the membrane&#8217;s response to the
pressure. We must then transform the formula (<code class="docutils literal"><span class="pre">Expression</span></code>) to a
finite element function (<code class="docutils literal"><span class="pre">Function</span></code>). The most natural approach is to
construct a finite element function whose degrees of freedom are
calculated from <span class="math">\(p\)</span>. That is, we interpolate <span class="math">\(p\)</span> to the function space
<span class="math">\(V\)</span>:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">p</span> <span class="o">=</span> <span class="n">interpolate</span><span class="p">(</span><span class="n">p</span><span class="p">,</span> <span class="n">V</span><span class="p">)</span>
</pre></div>
</div>
<p>Note that the assignment to <code class="docutils literal"><span class="pre">p</span></code> destroys the previous <code class="docutils literal"><span class="pre">Expression</span></code>
object <code class="docutils literal"><span class="pre">p</span></code>, so if it is of interest to still have access to this
object, another name must be used for the <code class="docutils literal"><span class="pre">Function</span></code> object returned
by <code class="docutils literal"><span class="pre">interpolate</span></code>. The two functions <code class="docutils literal"><span class="pre">w</span></code> and <code class="docutils literal"><span class="pre">p</span></code> may be plotted
using the built-in plot command:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">plot</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">title</span><span class="o">=</span><span class="s1">&#39;Deflection&#39;</span><span class="p">)</span>
<span class="n">plot</span><span class="p">(</span><span class="n">p</span><span class="p">,</span> <span class="n">title</span><span class="o">=</span><span class="s1">&#39;Load&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>As before, we also export the solutions in VTK format for
visualization in ParaView:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="n">vtkfile_w</span> <span class="o">=</span> <span class="n">File</span><span class="p">(</span><span class="s1">&#39;poisson_membrane/deflection.pvd&#39;</span><span class="p">)</span>
<span class="n">vtkfile_w</span> <span class="o">&lt;&lt;</span> <span class="n">w</span>
<span class="n">vtkfile_p</span> <span class="o">=</span> <span class="n">File</span><span class="p">(</span><span class="s1">&#39;poisson_membrane/load.pvd&#39;</span><span class="p">)</span>
<span class="n">vtkfile_p</span> <span class="o">&lt;&lt;</span> <span class="n">p</span>
</pre></div>
</div>
<p>Figure <a class="reference internal" href="#fig-poisson-membrane-deflection-load"><span>Plot of the deflection (left) and load (right) for the membrane problem created using ParaView. The plot uses 10 equispaced isolines for the solution values and the optional jet colormap</span></a> shows a visualization
of the deflection <code class="docutils literal"><span class="pre">w</span></code> and the load <code class="docutils literal"><span class="pre">p</span></code> created with ParaView.</p>
<div class="figure" id="id8">
<span id="fig-poisson-membrane-deflection-load"></span><a class="reference internal image-reference" href="_images/poisson_membrane_deflection_load.png"><img alt="_images/poisson_membrane_deflection_load.png" src="_images/poisson_membrane_deflection_load.png" style="width: 800px;" /></a>
<p class="caption"><span class="caption-text">Plot of the deflection (left) and load (right) for the membrane problem created using ParaView. The plot uses 10 equispaced isolines for the solution values and the optional <em>jet</em> colormap</span></p>
</div>
</div>
<div class="section" id="making-curve-plots-through-the-domain-1">
<h3>Making curve plots through the domain<a class="headerlink" href="#making-curve-plots-through-the-domain-1" title="Permalink to this headline">¶</a></h3>
<span class="target" id="index-51"></span><p>Another way to compare the deflection and the load is to make a curve plot
along the line <span class="math">\(x=0\)</span>. This is just a matter of defining a set of points
along the <span class="math">\(y\)</span>-axis and evaluating the finite element functions <code class="docutils literal"><span class="pre">w</span></code> and <code class="docutils literal"><span class="pre">p</span></code>
at these points:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="c1"># Curve plot along x = 0 comparing p and w</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="n">tol</span> <span class="o">=</span> <span class="mf">0.001</span>  <span class="c1"># avoid hitting points outside the domain</span>
<span class="n">y</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span> <span class="o">+</span> <span class="n">tol</span><span class="p">,</span> <span class="mi">1</span> <span class="o">-</span> <span class="n">tol</span><span class="p">,</span> <span class="mi">101</span><span class="p">)</span>
<span class="n">points</span> <span class="o">=</span> <span class="p">[(</span><span class="mi">0</span><span class="p">,</span> <span class="n">y_</span><span class="p">)</span> <span class="k">for</span> <span class="n">y_</span> <span class="ow">in</span> <span class="n">y</span><span class="p">]</span>  <span class="c1"># 2D points</span>
<span class="n">w_line</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">w</span><span class="p">(</span><span class="n">point</span><span class="p">)</span> <span class="k">for</span> <span class="n">point</span> <span class="ow">in</span> <span class="n">points</span><span class="p">])</span>
<span class="n">p_line</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">p</span><span class="p">(</span><span class="n">point</span><span class="p">)</span> <span class="k">for</span> <span class="n">point</span> <span class="ow">in</span> <span class="n">points</span><span class="p">])</span>
<span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="mi">50</span><span class="o">*</span><span class="n">w_line</span><span class="p">,</span> <span class="s1">&#39;k&#39;</span><span class="p">,</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>  <span class="c1"># magnify w</span>
<span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">p_line</span><span class="p">,</span> <span class="s1">&#39;b--&#39;</span><span class="p">,</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="bp">True</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s1">&#39;$y$&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">([</span><span class="s1">&#39;Deflection ($</span><span class="se">\\</span><span class="s1">times 50$)&#39;</span><span class="p">,</span> <span class="s1">&#39;Load&#39;</span><span class="p">],</span> <span class="n">loc</span><span class="o">=</span><span class="s1">&#39;upper left&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="s1">&#39;poisson_membrane/curves.pdf&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="s1">&#39;poisson_membrane/curves.png&#39;</span><span class="p">)</span>
</pre></div>
</div>
<p>This example program can be found in the file <a class="reference external" href="https://fenicsproject.org/pub/tutorial/python/vol1/ft02_poisson_membrane.py">ft02_poisson_membrane.py</a>.</p>
<p id="index-52">The resulting curve plot is shown in Figure
<a class="reference internal" href="#fig-poisson-membrane-curves"><span>Plot of the deflection and load for the membrane problem created using Matplotlib and sampling of the two functions along the  \( y \) -axsis</span></a>. The localized input (<span class="math">\(p\)</span>) is heavily
damped and smoothed in the output (<span class="math">\(w\)</span>). This reflects a typical
property of the Poisson equation.</p>
<div class="figure" id="id9">
<span id="fig-poisson-membrane-curves"></span><a class="reference internal image-reference" href="_images/poisson_membrane_curves.png"><img alt="_images/poisson_membrane_curves.png" src="_images/poisson_membrane_curves.png" style="width: 800px;" /></a>
<p class="caption"><span class="caption-text"><em>Plot of the deflection and load for the membrane problem created using Matplotlib and sampling of the two functions along the  \( y \) -axsis</em></span></p>
</div>
</div>
</div>
</div>


    </div>
  </div>
</div>
 <script type="text/javascript">
    $(document).ready(function() {
        $(".toggle > *").hide();
        $(".toggle .header").show();
        $(".toggle .header").click(function() {
            $(this).parent().children().not(".header").toggle(400);
            $(this).parent().children(".header").toggleClass("open");
        })
    });
</script>

  </body>
</html>